Package io.vertx.rxjava3.ext.auth.oauth2.providers

## Class IBMCloudAuth

- java.lang.Object
- - io.vertx.rxjava3.ext.auth.oauth2.providers.OpenIDConnectAuth
  - - io.vertx.rxjava3.ext.auth.oauth2.providers.IBMCloudAuth

-     public class IBMCloudAuth
      extends OpenIDConnectAuth

  Simplified factory to create an for IBM Cloud.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<IBMCloudAuth>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `IBMCloudAuth​(IBMCloudAuth delegate)` |
    `IBMCloudAuth​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static OAuth2Auth` | `create​(Vertx vertx, String region, String clientId, String clientSecret, String guid)` | Create a OAuth2Auth provider for IBM Cloud
    `static OAuth2Auth` | `create​(Vertx vertx, String region, String clientId, String clientSecret, String guid, HttpClientOptions httpClientOptions)` | Create a OAuth2Auth provider for IBM Cloud
    `static Single<OAuth2Auth>` | `discover​(Vertx vertx, OAuth2Options config)` | Create a OAuth2Auth provider for OpenID Connect Discovery.
    `boolean` | `equals​(Object o)` |
    `IBMCloudAuth` | `getDelegate()` |
    `int` | `hashCode()` |
    `static IBMCloudAuth` | `newInstance​(IBMCloudAuth arg)` |
    `static Single<OAuth2Auth>` | `rxDiscover​(Vertx vertx, OAuth2Options config)` | Create a OAuth2Auth provider for OpenID Connect Discovery.
    `String` | `toString()` |

    - ### Methods inherited from class io.vertx.rxjava3.ext.auth.oauth2.providers.OpenIDConnectAuth

      `newInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<IBMCloudAuth> __TYPE_ARG

  - ### Constructor Detail

    - #### IBMCloudAuth

          public IBMCloudAuth​(IBMCloudAuth delegate)

    - #### IBMCloudAuth

          public IBMCloudAuth​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `OpenIDConnectAuth`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `OpenIDConnectAuth`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `OpenIDConnectAuth`

    - #### getDelegate

          public IBMCloudAuth getDelegate()

      Overrides:
        `getDelegate` in class `OpenIDConnectAuth`

    - #### create

          public static OAuth2Auth create​(Vertx vertx,
                                          String region,
                                          String clientId,
                                          String clientSecret,
                                          String guid)

      Create a OAuth2Auth provider for IBM Cloud
      Parameters:
        `vertx` -
        `region` - the region to use
        `clientId` - the client id given to you by IBM Cloud
        `clientSecret` - the client secret given to you by IBM Cloud
        `guid` - the guid of your application given to you by IBM Cloud
      Returns:

    - #### create

          public static OAuth2Auth create​(Vertx vertx,
                                          String region,
                                          String clientId,
                                          String clientSecret,
                                          String guid,
                                          HttpClientOptions httpClientOptions)

      Create a OAuth2Auth provider for IBM Cloud
      Parameters:
        `vertx` -
        `region` - the region to use
        `clientId` - the client id given to you by IBM Cloud
        `clientSecret` - the client secret given to you by IBM Cloud
        `guid` - the guid of your application given to you by IBM Cloud
        `httpClientOptions` - custom http client options
      Returns:

    - #### discover

          public static Single<OAuth2Auth> discover​(Vertx vertx,
                                                    OAuth2Options config)

      Create a OAuth2Auth provider for OpenID Connect Discovery. The discovery will use the default site in the configuration options and attempt to load the well known descriptor. If a site is provided (for example when running on a custom instance) that site will be used to do the lookup.

      If the discovered config includes a json web key url, it will be also fetched and the JWKs will be loaded into the OAuth provider so tokens can be decoded.

      Parameters:
        `vertx` - the vertx instance
        `config` - the initial config
      Returns:
        future with instantiated Oauth2 provider instance handler

    - #### rxDiscover

          public static Single<OAuth2Auth> rxDiscover​(Vertx vertx,
                                                      OAuth2Options config)

      Create a OAuth2Auth provider for OpenID Connect Discovery. The discovery will use the default site in the configuration options and attempt to load the well known descriptor. If a site is provided (for example when running on a custom instance) that site will be used to do the lookup.

      If the discovered config includes a json web key url, it will be also fetched and the JWKs will be loaded into the OAuth provider so tokens can be decoded.

      Parameters:
        `vertx` - the vertx instance
        `config` - the initial config
      Returns:
        future with instantiated Oauth2 provider instance handler

    - #### newInstance

          public static IBMCloudAuth newInstance​(IBMCloudAuth arg)